﻿Imports QCAP.NET

Public Class Form1

    
    Public m_pDevices() As UInt32 = {0, 0, 0, 0} ' CAPTURE DEVICE

     Shared HandleAffichage As IntPtr                'Handle de la fenêtre d'affichage

    Public b_IsStartRecord() As UInt32 = {0, 0, 0, 0} ' IS THIS CHANNEL STARTED RECORD

    Public m_strFormatChangedOutput() As String = {"", "", "", ""}

    Public m_bNoSignal() As Boolean = {True, True, True, True}

    Public b_bitmap() As Boolean = {False, False, False, False}

    Dim pDstABGRBuffer() As Integer = {0, 0, 0, 0}

    Dim bmp As Bitmap
    Dim g As Graphics

    Dim redPen2 As New Pen(Color.Red, 2)

    Dim redPenLarge As New Pen(Color.Red, 3)

    Public pCallback As EXPORTS.PF_SNAPSHOT_STREAM_CALLBACK = Nothing
    Dim pUserData As UInteger = 0

    Public b_HeapAlloc() As Boolean = {False, False, False, False}
    ' Constructeur du formulaire
    Public Sub New()
        ' Cet appel est requis par le concepteur.
        InitializeComponent()
        '--- Divers Init
        HandleAffichage = m_statDisplayWindow0.Handle        'Handle de la zone d'affichage
    End Sub
    ' CALLBACK FUNCTION


    Public Function imageCallback(ByVal pDevice As UInt32, ByVal pFileName As String, ByVal pStreamBuffer As UInt32, ByVal nStreamBufferLen As UInt32, ByVal pUserData As UInt32) As EXPORTS.ReturnOfCallbackEnum

        bmp = New System.Drawing.Bitmap(pStreamBuffer)

        Invoke(New EventHandler(AddressOf routine))

        Return EXPORTS.ReturnOfCallbackEnum.QCAP_RT_OK

    End Function
    '
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_pDevices(0) = 0

        HwInitialize()

    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        HwUnInitialize()

    End Sub


    Public Sub HwInitialize()

        Dim i As UInt32 = 0

        Dim m_ChipName0 As String = "TW6802 PCI"



        ' CREATE CAPTURE DEVICE            
        '
        EXPORTS.QCAP_CREATE(m_ChipName0, 0, m_statDisplayWindow0.Handle.ToInt32(), m_pDevices(0), 1)

        ' REGISTER NO SIGNAL DETECTED CALLBACK FUNCTION
        '
        '     EXPORTS.QCAP_REGISTER_NO_SIGNAL_DETECTED_CALLBACK(m_pDevices(i), m_pNoSignalDetectedCB, i)

        pCallback = New EXPORTS.PF_SNAPSHOT_STREAM_CALLBACK(AddressOf imageCallback)

        EXPORTS.QCAP_REGISTER_SNAPSHOT_STREAM_CALLBACK(m_pDevices(0), pCallback, pUserData)

        EXPORTS.QCAP_SET_VIDEO_STANDARD(m_pDevices(0), EXPORTS.VideoStandardTypeEnum.QCAP_STANDARD_TYPE_PAL_B)

        EXPORTS.QCAP_RUN(m_pDevices(0))

        'Timer1.Enabled = True



    End Sub


    Public Sub HwUnInitialize()

        Dim i As UInt32 = 0




        If m_pDevices(0) <> 0 Then

            EXPORTS.QCAP_STOP(m_pDevices(0))

            EXPORTS.QCAP_DESTROY(m_pDevices(0))

        End If



    End Sub

    Sub routine()

        Dim x1, x2, y1, y2 As Short
        Dim mySolidBrush As New SolidBrush(Color.White)
        Dim rayon As Integer = 1 * 1.5625
        Dim customColor As Color = Color.FromArgb(80, Color.Red)
        Dim shadowBrush As SolidBrush = New SolidBrush(customColor)

        redPen2.DashStyle = Drawing2D.DashStyle.Dash
        g = Graphics.FromImage(bmp)

        x1 = 0
        y1 = 250
        x2 = (983)
        y2 = 250
        g.DrawLine(redPenLarge, x1, y2, x2, y1)
        'repères sur la cible

        For I4 = 1 To 12
            x1 = (100 * I4)
            y1 = 240
            x2 = (100 * I4)
            y2 = 260
            If y2 <> y1 Then
                g.DrawLine(redPenLarge, x1, y1, x2, y2)
            End If
        Next I4


        g.Dispose() ' libération de l'interface graphique
        Dim gr As Graphics = Graphics.FromHwndInternal(HandleAffichage)
        gr.DrawImage(bmp, 0, 0)
        gr.Dispose()


        System.Windows.Forms.Application.DoEvents()
    End Sub






End Class
